










                            Pas-Ed (TM) version 1.4
                        Programmer's Editor for Pascal


                               Ŀ
                                USER'S MANUAL 
                               


                       Copyright (C) 1989 by Hedco, Inc.
                             All rights reserved.

                                November, 1989


                           


                                  Hedco, Inc.
                                 P.O. Box 606
                           Tehachapi, CA 93581   USA

                           Telephone: (805) 821-0167
                Monday through Friday, 9am to 5pm Pacific time

                           On CompuServe: 76137,1656




















Title Page                                                         Pas-Ed Manual






                           Copyrights and Trademarks
                           


Pas-Ed version 1.4 is copyrighted (C) 1989 by Hedco, Inc.

Pas-Ed and Hedco are trademarks of Hedco, Inc.

Turbo Pascal, Turbo Debugger, Turbo Assembler, and Sidekick are registered
trademarks of Borland International, Inc.

TurboPower Software is a trademark of TurboPower Software, Inc.

WordStar is a registered trademark of WordStar International, Inc.

IBM is a registered trademark of International Business Machines Corporation.





Acknowledgments


The EMS/Disk swapping routine is based on the public domain unit EXECSWAP, and
the prompt in the DOS shell is based on the public domain unit TPENV, both
written by Kim Kokkonen, president of TurboPower Software.
























Preface                                                  Pas-Ed Manual - Page i



                           Pas-Ed License Agreement
                           


DEFINITIONS


Hedco - Hedco, Inc.
Pas-Ed - The Pas-Ed software and documentation.


LICENSE


Pas-Ed is a copyrighted, proprietary program of Hedco.  A single-user limited
license is granted to you to use Pas-Ed for your personal use for a fifteen (15)
day trial period.  If you would like to purchase a single-user license to
continue to use Pas-Ed after the trial period, you may do so by making a $25
payment to Hedco at the address shown on the Title Page of this manual.  To
purchase a group license, contact Hedco for fees and instructions.  If you do
not purchase a license from Hedco to use Pas-Ed, you must discontinue use of
Pas-Ed after the 15 day trial period.


LIMITED, EXCLUSIVE WARRANTY


Hedco warrants that the software will perform substantially as described in the
documentation for a period of 30 days from the date of purchase.  Hedco makes no
other warranty or representation, either express or implied, with respect to the
software or its documentation, their quality, performance, merchantability, or
fitness for a particular purpose.  This Limited Warranty is void if the software
or documentation has been abused, misapplied, or altered.


LIABILITY DISCLAIMER AND REMEDIES


In no event will Hedco be liable for direct, indirect, special, incidental or
consequential damages arising out of the use or inability to use Pas-Ed even if
Hedco has been advised of the possibility of such damages, and the entire and
exclusive liability and remedy shall be to return Pas-Ed to Hedco within the
warranty period for replacement or refund.


GOVERNING LAW


This License Agreement shall be governed by the laws of the State of California,
and any action filed hereunder shall only be brought in Kern County, California.




Preface                                                  Pas-Ed Manual - Page ii




                               Table of Contents
                               


         Preface                                               Page  i
         Copyrights and Trademarks ............................      i
         Acknowledgments ......................................      i
         Pas-Ed License Agreement .............................     ii


         Chapter 1   Introduction To Pas-Ed                    Page  1
         About This Manual ....................................      1
         About Pas-Ed .........................................      1
         System Requirements ..................................      3
         Before Running Pas-Ed ................................      4
         Contacting Hedco .....................................      4


         Chapter 2   What's New In Version 1.4                 Page  5
         New Features .........................................      5


         Chapter 3   Setting Up Pas-Ed                         Page  9
         Pas-Ed Files .........................................      9
         Getting Pas-Ed Ready .................................      9
         Starting Pas-Ed ......................................     10
         The Status Line ......................................     11
         Navigating The Menu System ...........................     11
         The Options Menu .....................................     12
         The Color Chart ......................................     14
         The User Utilities ...................................     15
         Setting Up The Macros ................................     16
         Setting Up The Files .................................     16
         Setting Up Turbo Pascal ..............................     17
         Ready To Go ..........................................     17


         Chapter 4   A Tour Of Pas-Ed                          Page 18
         Getting Ready ........................................     18
         Restoring Your Setup .................................     18
         The Editor ...........................................     18
         Switching Exec Files and Directories .................     20
         The Window Menu ......................................     21
         The Search Menu ......................................     21
         The Macro Menu .......................................     22
         The Other Menus ......................................     23
         The Pop-up Tables ....................................     23
         Switching Video Modes ................................     23





Table of Contents                                                  Pas-Ed Manual




                         Table of Contents (continued)
                         


         Chapter 5   The Pas-Ed Menu System                    Page 24
         About The Menus ......................................     24
         The Menu Selections ..................................     24
         File Menu ............................................     24
         Window Menu ..........................................     26
         Edit Menu ............................................     27
         Search Menu ..........................................     27
         Macros Menu ..........................................     28
         Compile Menu .........................................     29
         Run Menu .............................................     30
         Debug Menu ...........................................     30
         Language Menu ........................................     31
         Options Menu .........................................     35


         Chapter 6   The Pas-Ed Editor                         Page 40
         About The Editor .....................................     40
         The Editor Message Line ..............................     40
         The Editor Status Line ...............................     41
         The Function Keys ....................................     41
         Entering Text ........................................     43


         Chapter 7   Hints On Using Pas-Ed                     Page 44

























Table of Contents                                                  Pas-Ed Manual




                      Chapter 1 - Introduction To Pas-Ed
                      



About This Manual


This manual is organized into seven chapters:

     Chapter 1 - Introduction To Pas-Ed (this chapter)
     Chapter 2 - What's New In Version 1.4
     Chapter 3 - Setting Up Pas-Ed
     Chapter 4 - A Tour of Pas-Ed
     Chapter 5 - The Pas-Ed Menu System
     Chapter 6 - The Pas-Ed Editor
     Chapter 7 - Hints on Using Pas-Ed

It's assumed in this manual that you're familiar with Turbo Pascal and the Turbo
Integrated Development Environment (IDE).  The Pas-Ed editor is identical to the
editor in the Turbo IDE.  This manual doesn't attempt to explain the intricacies
of Turbo Pascal or of WordStar-type editors.  These subjects are covered in
detail in the Turbo Pascal manuals, which you're assumed to have.

This manual strives to get you, the programmer, up and running with Pas-Ed in as
little time as possible.  This is accomplished via a hands-on, setup tutorial in
Chapter 3 - Setting Up Pas-Ed.  Completing this tutorial should take about 15-20
minutes, by which time you should have Pas-Ed set up to your liking.  Those who
are already familiar with Pas-Ed should read Chapter 2 - What's New In Version
1.4, which explains the new features added to version 1.4.

Users familiar with the Turbo IDE or Sidekick should have no trouble running
Pas-Ed at that point.  Those who would like a more complete introduction are
encouraged to read Chapter 4 - A Tour of Pas-Ed, which steps you through some of
the more important features of Pas-Ed as they're explained.

With all the new features added to version 1.4, even experienced Pas-Ed users
should read Chapter 3 - Setting Up Pas-Ed and Chapter 4 - A Tour of Pas-Ed.

We also recommend browsing through Chapter 7 - Hints on Using Pas-Ed.



About Pas-Ed


Pas-Ed is an ASCII file programmer's editor created to streamline the process of
editing, compiling, debugging, and running programs written in Turbo Pascal.
Since it's an ASCII file editor, Pas-Ed can also be used to edit programs for




Chapter 1 - Introduction To Pas-Ed                       Pas-Ed Manual - Page 1




other compilers, but it will be clear when you run Pas-Ed that it's main forte
is Turbo Pascal.  Pas-Ed's support for Turbo Pascal is unmatched by any other
programmer's editor.  Pas-Ed combines the ease of use of the Turbo IDE with
sophisticated multi-file and memory handling abilities to allow you to write
programs far larger than with the Turbo IDE.  Some of Pas-Ed's features include:

     - An integrated development environment for ease of use.

     - Edit up to 21 files in a combination of DOS and EMS memory.

     - Windows can be individually opened and closed, zoomed and unzoomed,
       hidden and unhidden, and recolored.

     - Easy movement between the windows using both "hot key" commands and the
       Memory-Files and Recent-Files Pick lists.

     - Five user-selected utilities, each with its own command line, can be
       built into and run from the menus.

     - 43/50 line screen modes on EGA/VGA systems with a "hot key" video mode
       selector.

     - Switch between 25 and 28 lines as the standard screen height (providing
       your video system is in 28 line mode).

     - Direct menu support for all Turbo Pascal compiler and linker switches.

     - Automatic TPC.CFG compiler configuration file generation based on menu
       selections.

     - EMS or disk swapping during DOS shells and compile, debug and run
       sessions, which reduces Pas-Ed's DOS memory usage to only 6K.

     - Set up a project file which can easily be "hot keyed" as the program to
       compile, run, or debug.

     - When entering file names, the file path can be "hot keyed" between the
       current directory, the Pas-Ed directory, and the EXE/TPU directory.

     - Pass a command line to programs being run.

     - Menu-operated debugging from within Pas-Ed using Turbo Debugger, and you
       can pass a command line to both Turbo Debugger and the program being
       debugged.

     - Automatic error locating including /F Find Error.

     - Automatic restoration of the previous setup at startup.





Chapter 1 - Introduction To Pas-Ed                       Pas-Ed Manual - Page 2




     - Keyboard macros with adjustable playback delay.

     - Inter-file block copy and move of text.

     - Block indent and unindent with adjustable spacing.

     - Find and replace using text from a marked block.

     - 10 placemarkers that operate within and between files, including files on
       disk.

     - Jump to a specific file or line number.

     - Adjustable cursor size.

     - Pop-up ASCII character table (shows the ASCII character and its decimal,
       hex, and binary values, plus, if the ASCII value is under 32, the control
       code).

     - Pop-up extended key code table (shows the extended key codes of the
       function keys, <Alt> + keys, arrow keys, etc.).



System Requirements


Hedco recommends that you run Pas-Ed on a computer system with at least 512k of
DOS memory and a hard disk.  EMS memory is not required.  Pas-Ed will run on a
high-capacity floppy disk system, but you should realize that DOS memory swaps
will necessarily be slow if they must be made to disk.  Also, because Pas-Ed
leaves such a small kernel in memory when swapped out, swap sizes will approach
the amount of free DOS memory as reported by CHKDSK.  This could be a problem on
floppy disk systems.  In the following example of a 720k floppy drive system,
CHKDSK reports 451,328 bytes of free memory, which gives a good approximation of
the size of the swap file:

     A:\>chkdsk

        730112 bytes total disk space
         45056 bytes in 2 hidden files
        214016 bytes in 7 user files
        471040 bytes available on disk

        655360 bytes total memory
        451328 bytes free

In the example, with only 471,040 bytes available on disk and a swap file size
of close to 451,328 bytes, there will be almost no room left on the disk for the




Chapter 1 - Introduction To Pas-Ed                       Pas-Ed Manual - Page 3




compiled program and/or for using a disk link buffer after the swap file has
been written to disk.  Systems with dual 720k floppy drives will necessarily
need to use both drives, and lesser systems will be unable to run Pas-Ed.  If
you are running Pas-Ed on a floppy disk system and have no EMS memory and only
one or two edit window open, try turning EMS/Disk swapping off during DOS shells
or when compiling very small programs.  Pas-Ed compresses the heap when EMS/Disk
swapping is disabled, and exec sessions requiring minimal amounts of memory
should operate without problem.  If you get insufficient memory messages, turn
EMS/Disk swapping back on or close the second window if you have two windows
open, and enable disk linking.



Before Running Pas-Ed


Before running Pas-Ed, check: 1) the directory you plan to start Pas-Ed from
(which may be different from the directory containing the Pas-Ed files); 2) the
directory containing the TPC.EXE Turbo Pascal command line compiler; 3) the
Pas-Ed directory; and 4) any directories on the DOS path.  What you're looking
for are extra copies of the TPC.CFG compiler configuration file.  Delete any
copies of this file found.  Pas-Ed will create an updated TPC.CFG file before
compiles using your latest menu settings.  Extra copies of the TPC.CFG file
which are further up the DOS path than the one Pas-Ed creates will be used by
the compiler instead of the one created by Pas-Ed, causing unpredictable
results.

Remember that you can specify a full path name for TPC.CFG, so you can instruct
Pas-Ed to write the TPC.CFG file into the directory with the compiler and thus
eliminate path problems altogether.



Contacting Hedco


Pas-Ed is continually evolving to meet the needs of Pascal programmers.  As you
use Pas-Ed, you'll undoubtedly think of additional features which Pas-Ed should
have or changes that might enhance the program.  Please write Hedco with your
suggestions or comments.  Our address is:

     Hedco, Inc.
     P.O. Box 606
     Tehachapi, CA 93581
     USA

     Telephone: (805) 821-0167
                Monday through Friday, 9am to 5pm Pacific time

     On CompuServe: 76137,1656



Chapter 1 - Introduction To Pas-Ed                       Pas-Ed Manual - Page 4




                     Chapter 2 - What's New In Version 1.4
                     



New Features


Because of the quickness of the update to version 1.4, this listing also
contains the new features added to the previous version.

Pas-Ed version 1.4 contains a wealth of new features to make your Turbo Pascal
programming easier.  All the new features were added at user request, and we
encourage you to send us your suggestions on how to improve Pas-Ed.

The following is a list of the new features along with an explanation of their
operation:

     - Pas-Ed now searches for the PAS-ED.CFG configuration file along the DOS
       path so you can start Pas-Ed from any directory or drive as long as
       you've properly set up the path.

     - Pas-Ed now has two Pick lists.  The original Pick list (the Memory-Files
       Pick list) contained the files loaded in memory.  This Pick list is still
       available through the Window/M-Pick menu option and from the editor via
       <Alt-F3>.

       The new Pick list (the Recent-Files Pick list) contains the ten most
       recently edited files, and is available through the File/R-Pick menu
       option and from the editor via <Ctrl-F3>.  If the file chosen from this
       list is in memory, Pas-Ed will switch to it, and if the file isn't in
       memory, Pas-Ed will load the file into the current window and reposition
       the cursor to where it was when the file was last being edited.  Like the
       Memory-Files Pick list, this Pick list will jump into hidden windows.
       This Pick list is saved in the PAS-ED.CFG configuration file and restored
       at startup.

     - Pas-Ed's placemarkers now jump into disk files as well as in-memory
       files.  If the file with the placemarker is in memory, Pas-Ed will switch
       to it and reposition the cursor to where it was when the placemarker was
       set, even if the file is in a different window from the one where the
       placemarker was set or if the file has been hidden.  If the file isn't in
       memory, Pas-Ed will load the file into the current window and reposition
       the cursor.  In addition, the placemarkers are now saved in the
       PAS-ED.CFG configuration file and restored at startup.

     - Pas-Ed now supports block indent and unindent via the ^KI and ^KU block
       commands.  The number of spaces to indent or unindent can be set through
       the Options/Indent/Unindent menu option, and is saved in the PAS-ED.CFG
       configuration file and restored at startup.



Chapter 2 - What's New In Version 1.4                    Pas-Ed Manual - Page 5




     - In the Options/Edit File Save selection, the "No" file save option has
       been renamed to the more descriptive "Browse."  Note that Pas-Ed still
       allows you to freely edit and cut and paste from a Browse file; Pas-Ed
       will simply clear the edit buffer without saving the file when a new file
       is loaded or when exiting Pas-Ed.  If necessary, a file save can be
       forced with either the File/Save menu selection or the <F2> editing
       command, and Pas-Ed will now verify a Browse file save before saving the
       file.

     - Pas-Ed now enters the editor immediately after the opening screen and
       automatically loads the files you were previously editing without cycling
       the files through the File Name window.  Pas-Ed also accepts file names
       as command line parameters, with ".PAS" as the default extension.  An
       example would be:

            C>pas-ed file1 file2 file3.asm

       In this example, instead of loading your previous files, Pas-Ed would
       load FILE1.PAS, FILE2.PAS, and FILE3.ASM.  If you specify more files than
       can fit into available memory, Pas-Ed will load as many files as
       possible.

     - Pas-Ed now returns directly to editor after actions which were initiated
       by direct commands from the editor, such as the <Alt-F3> and <Ctrl-F3>
       Pick lists, the <F9> make command, etc.

     - The "hot key" commands now work from everywhere in Pas-Ed including the
       pop-up edit message and edit windows.

     - Pas-Ed returns directly to the menus after full DOS shells.  Single
       command DOS shells still require the <Esc> key to be pressed, as this
       allows you to see the on-screen results of the command before returning
       to Pas-Ed.

     - The default NONAME file format has been changed to PAS-xxxx.PAS so that
       the file names show up on default "*.PAS" directories.

     - The File/Clear command now changes the name in the current window to a
       default PAS-xxxx.PAS file name after clearing the edit buffer to prevent
       accidentally erasing a file.

     - The cursor size is now adjustable through the Options/Cursor Size option.

     - The editor's window commands have been expanded in a logical manner:

            - The <F3> command loads a file, and now <Alt-F3> calls up the
              Memory-Files Pick list and <Ctrl-F3> the Recent-Files Pick list.






Chapter 2 - What's New In Version 1.4                    Pas-Ed Manual - Page 6




            - The <F4> command opens a window, and now <Alt-F4> closes the
              current window.

            - The <F6> command rotates forward through the windows, and now
              <Alt-F6> rotates backward through the windows.

     - There is a new Options/Verify Before Exit switch.  If this option is on
       and you give an exit command, the "Verify exit" message appears and you
       must verify the exit before Pas-Ed will exit to DOS.  If this option is
       off, Pas-Ed immediately exits to DOS without verifying.

     - The available DOS and EMS memory are displayed in Options/Memory Usage
       submenu.

     - Pas-Ed now has five user-selected utilities built into the menu system.
       These utilities may be any executable or batch files, and are started via
       the File/Utilities menu selection.  The names of the five utilities are
       entered via the Options/Name User Utilities selection.  ".EXE" is the
       default extension, and any file name entered without an extension will
       have ".EXE' appended to it.  You may also enter a command line for each
       utility which is then passed to the utility when it's called.  The names
       of the utilities and their command lines are saved in the PAS-ED.CFG
       configuration file and restored at startup.

     - Pas-Ed can now pass a command line to the file being run, and the command
       line may be edited via the Language/Files submenu or just prior to the
       run session.

     - Pas-Ed now passes a command line to Turbo Debugger, and the command line
       may be edited via the Language/Files submenu or just prior to the debug
       session.  Pas-Ed can also pass the Run Command Line to the program being
       debugged.

     - Pas-Ed now has a project file, which can be edited via the Language/Files
       submenu.  When entering the name of a file to compile, run, or debug or
       when entering one of five the user utilities, the new <Alt-N> (for Name)
       command switches the file name between the project file and the file in
       the current window.

     - Also when entering the name of a file to compile, run, or debug or when
       entering one of five the user utilities, the new <Alt-P> command switches
       the directory path between the current directory, the Pas-Ed directory,
       and the EXE/TPU directory.

     - The Unit, Include, and Object directories passed to the TPC.EXE compiler
       have been expanded to 125 characters.

     - Pas-Ed's memory usage during DOS memory swaps has been reduced to just 6k
       of DOS memory.




Chapter 2 - What's New In Version 1.4                    Pas-Ed Manual - Page 7




     - Pas-Ed now searches for the macro file along the path, and will change
       the macro file name when found to include the correct path.

     - Pas-Ed now checks your file before saving for errant End-Of-File markers
       that could result in the loss of the portions of your file that follow
       the marker.  Any End-OF-File markers imbedded in the body of your source
       code are changed to spaces.  End-Of-File markers in the source code form
       of "^Z" and "#26" are not affected.

     - The default directory can now be changed via the File/New Dir option.

     - After a DOS shell, Pas-Ed automatically switches back to the default
       directory.

     - The status line can now be recovered and used for editing via the
       Options/Editor Status Line option.

     - The new <Alt-V> "hot key" toggles between 25 and 43/50 line screen modes
       from either the editor or the menus.

     - Pas-Ed can now switch between 25 and 28 lines as the standard screen
       height, providing your video system is in 28 line mode, using the
       Options/Type of Monitor submenu.

     - The new <Alt-F1> "hot key" displays the last DOS screen.

     - When changing colors using the Color Chart, the down arrow now reduces
       the byte color value and the up arrow increases it.

























Chapter 2 - What's New In Version 1.4                    Pas-Ed Manual - Page 8




                         Chapter 3 - Setting Up Pas-Ed
                         



Pas-Ed Files


If you haven't already done so, make backup copies of the Pas-Ed files.  The
complete Pas-Ed package includes the following files:

     PAS-ED.EXE    The Pas-Ed program.  This is the only file needed to run
                   Pas-Ed.

     PAS-ED.MAC    The sample macro file.

     PAS-ED.MAN    The complete, on-disk manual (this file).

     PAS-ED.CFG    The Pas-Ed configuration file.  This file is NOT included in
                   the Pas-Ed package, but is listed here for completeness.  It
                   is created by Pas-Ed when you exit the program, and contains
                   data representing the state of Pas-Ed upon exit.  It's used
                   to restore your last setup when you restart Pas-Ed.

By default, Pas-Ed uses the following programs from Borland International to
compile and debug Turbo Pascal programs:

     TPC.EXE       The Turbo Pascal compiler and library files.  These files are
     TURBO.TPL     used to compile your source code files.

     TD.EXE        Turbo Debugger.



Getting Pas-Ed Ready


Those unfamiliar with setting up directories and paths and copying files should
refer to your DOS or Turbo Pascal manuals.

The easiest way to set up Pas-Ed is to copy all the necessary Pas-Ed, compiler,
and debugger files into the same directory.  If this isn't feasible, another
method is to have the Pas-Ed, compiler, and debugger files in different
directories and use DOS' PATH command to tell DOS where to look for the files.
For example, if the compiler files were located on your hard disk drive C in the
directory \TP, the command would be:

     PATH=C:\TP





Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 9




This command is best entered into your AUTOEXEC.BAT file, and you can specify
several directories separated by ";", such as:

     PATH=C:\TP;C:\TD;D:\PAS-ED

If you've started Pas-Ed from a directory other than the one containing Pas-Ed,
Pas-Ed will follow the path to find it's configuration file, and Pas-Ed either
accepts full path names for the other files it needs or will follow the path to
find them, allowing Pas-Ed to be started from any directory.



Starting Pas-Ed


With Pas-Ed in the current directory or on the DOS path, type "PAS-ED" at the
DOS prompt.  The program will load from disk and the Pas-Ed license menu will
appear.  It will be necessary to accept the Pas-Ed License Agreement for the
program to continue.  The Pas-Ed License Agreement is located in the preface of
this manual.  This menu appears the first time Pas-Ed is started, and thereafter
the program is entered directly.

Since this is the first time the program has been run, there's no PAS-ED.CFG
configuration file for Pas-Ed to read to restore the prior setup.  A message to
this effect appears, which, if you had previously run Pas-Ed and had created a
configuration file, would alert you to possible corruption of the PAS-ED.CFG
file so you could recheck your configuration settings.  Press <Esc> to clear the
message, and the Pas-Ed copyright, trademark, and registration notice appears.

Press <Esc> to clear the notice, and you're immediately placed in the Pas-Ed
editor.  If you're not starting Pas-Ed from the Pas-Ed directory and not using
the DOS path to the Pas-Ed files, a message appears prior to the editor
notifying you that an error has occurred loading the macro file.  This is
normal, since Pas-Ed can't find the macro file in either the current directory
or along the path and you haven't yet given Pas-Ed a macro file name with a full
path attached.  Press <Esc> to clear this message and bring up the editor.

The editor is explained in greater detail in Chapter 6 - The Pas-Ed Editor.  For
now, notice that the top line of the screen contains the editor's message line,
and the bottom line contains the status line.  Notice also that the file name on
the top line of the screen is of the format "PAS-xxxx.PAS".  This is Pas-Ed's
default file format, and is used whenever Pas-Ed needs to open a new file.
Pas-Ed will initially try the file PAS-1.PAS.  If this file exists in the
current directory, Pas-Ed will open PAS-2.PAS, and if PAS-2.PAS exists, Pas-Ed
will open PAS-3.PAS, etc.








Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 10




The Status Line


The status line shows prompt or status information about Pas-Ed, and is always
visible unless you've recovered this line for editing via the Options/Editor
Status Line menu option, in which case the status line will appear only in the
menu system.  The status line is broken into three sections:

     - At the far left is the number of the currently active window.  Since
       window one is active, a "1" appears here.  If two windows were open and
       the second window were active, a "2" would be displayed. If macro
       recording were enabled, an "M" would be displayed next to the window
       number.  Thus, if the fourth window was active and macro recording were
       on, "4M" would be displayed.

     - In the middle is the prompt information about the system (menu or editor)
       currently active.  Since the editor is active, this section displays
       keyword explanations of the functions assigned to the function keys.  If
       the menu system were active, this section would display prompt
       information about the currently highlighted menu selection.

     - To the far right is the memory location of the active window.  If the
       active window had been allocated in DOS memory, "DOS" would be displayed;
       if in EMS memory, "EMS" would appear here.

Press <F10> to open the menu system.  The top line of the screen now contains
Pas-Ed's main menu.  Since "Edit" is highlighted, the status line briefly
explains the Edit menu option.



Navigating The Menu System


The menu system is navigated by using either the dedicated movement keys, such
as the arrow, Home, and End keys, or WordStar commands, such as <Ctrl-S> for
left, <Ctrl-D> for right, etc.  Pressing <Enter> when the light bar is over a
selection or pressing its highlighted letter selects it, and <Esc> deselects or
closes a menu.

Open the Options menu by pressing <Alt-O>.  All the main menu selections, such
as File, Window, Edit, Search, etc., are "hot-keyed", meaning they can be
selected from anywhere in Pas-Ed, including from the editor, by pressing the Alt
key and the first letter of the selection.  (The only exceptions to this are the
pop-up edit windows, since they use some of the hot keys for other commands.)
Try out the menu hot keys at this time by pressing <Alt-E> to go back to the
editor, then <Alt-O> to reopen the Options menu.






Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 11




The Options Menu


The Options menu contains most of the selections needed to set up Pas-Ed.

At the top of the Options menu is "Config auto save."  If this selection is on,
the PAS-ED.CFG configuration file is saved to disk whenever you exit the
program.  The PAS-ED.CFG file allows Pas-Ed to restore your previous setup when
you restart the program.  It's a good idea to leave this option on unless you
have reason not to.

The next selection is "Edit file save."  This selection brings up a submenu with
the choices "Auto", "Prompt", and "Browse."  These choices indicate how the file
in the active window will be saved.  If Auto is selected and the file has been
changed during the editing session, the file will automatically be saved prior
to a DOS shell or a debug or run session or before exiting the program.  Prompt
means you'll be prompted whether or not to save the file.  Browse means the file
has been opened for browsing only and it won't be saved and you won't be
prompted.  Note that the Browse selection doesn't prevent you from editing or
copying to or from the file; it only means the file won't be saved.  You can
force a file save if you wish using the File/Save menu option or <F2> from the
editor.  Pas-Ed will confirm the save before saving the file.

After you've made a selection, a submenu appears asking whether you want the
change to be effective for just the current window or for all windows.  Each
window can have its own setting.  Pressing <Esc> cancels the change.

In most cases, Auto is the best choice, although Browse is quite useful when
cutting and pasting routines from one of your library files.  If you set this
selection to Browse, remember to reset it once you resume normal editing in the
window, or else your editing changes won't be saved and you won't be prompted.

You may be wondering why changed files are saved prior to DOS shells, debug and
run sessions, and when running the user utilities.  The reason is that these are
the types of sessions where there's a good chance of a system crash, such as
when debugging or running a new program that has an undiscovered fatal bug,
which would cause you to lose all your editing changes.

The next selection on the Options menu is "Backup file," which determines
whether a ".BAK" file is created when the current file is saved.  This option is
usually best left on unless speed and/or disk space are factors, and here too
each window can have its own setting.

Next is "Macro auto save," which determines whether the in-memory macros are
automatically saved to disk prior to exiting the program.  This option is also
generally best left on.

Next is "verify before eXit."  If this option is on, Pas-Ed verifies that you
want to exit before it exits to DOS; if off, Pas-Ed immediately exits to DOS
without verifying.



Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 12




Next is "cuRsor size," which allows you to set the cursor size for the editing
and DOS shell windows.  The options are Block, Fat, and Normal.

Now press <U> for "memory Usage," which opens the Memory Usage submenu.  This
submenu determines how Pas-Ed will use the available DOS and EMS memory.  The
first selection on the Memory Usage submenu, "Swap to EMS/disk," determines
whether Pas-Ed will swap a DOS memory image to EMS memory or disk prior to a DOS
shell or a compile, debug, or run session or when running a user utility.  If
enabled, Pas-Ed swaps out of memory and frees up all but 6K of DOS memory for
the session.  If off, the heap is compressed and a standard DOS exec session is
initiated with whatever DOS memory is available (the amount of available DOS
memory will depend primarily on the number of windows you've opened and whether
you've allocated any new macros).

The second selection on the Memory Usage submenu, "Reserve EMS for swap,"
determines whether enough EMS memory will be reserved to hold a DOS memory swap.
If your system doesn't have EMS memory or if there's not enough EMS memory
available for the swap, Pas-Ed will prevent you from enabling this option and
the reason will be displayed in a pop-up window.

The third selection on the Memory Usage submenu, "Working memory", allows you to
specify the amount of DOS memory, in bytes, that Pas-Ed sets aside for internal
program use.  The default is 20,000 bytes, which should prove sufficient for
most situations.  This figure may have to be adjusted upward if your setup of
Pas-Ed uses a significant amount of working memory, such as if you've defined
numerous macros, opened a lot of windows, or are making large EMS-to-EMS block
copies and moves, etc.  (Since only one EMS-based file can be mapped into DOS
memory at once, EMS-to-EMS block transfers are temporarily stored in working
memory.)  If you get insufficient memory messages, then raise the amount of
working memory.

Press <Esc> to return to the Options menu, then <S> for "Screen colors."  The
Screen Colors submenu appears, displaying all the program color types.  An arrow
is displayed next to the Screen Colors submenu showing which color type is
currently selected.  Use the arrow, Home, and End keys to choose a color type to
change, then press <Enter>.

















Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 13




The Color Chart




   File  Window  Edit  Search  Macros  Compile  Run  Debug  Language  Options
Ŀ           ͻĿ
 Normal text color     <      New Value Ŀ      Old Value Ŀ   
 Highlighted text                           7                 7        
 Marked text block                           
 Text error message                   Color Chart Ŀ   
 Normal background                      0   1   2   3   4   5   6   7    
 Status line color                      8   9  10  11  12  13  14  15    
 Normal menu color                     16  17  18  19  20  21  22  23    
 Highlighted menu                      24  25  26  27  28  29  30  31    
 Selected menu item                    32  33  34  35  36  37  38  39    
 Menu border color                     40  41  42  43  44  45  46  47    
 Menu title color                      48  49  50  51  52  53  54  55   
 Normal message color                  56  57  58  59  60  61  62  63   
 Highlighted message                   64  65  66  67  68  69  70  71   
 Selected message item                 72  73  74  75  76  77  78  79   
 Message border color                  80  81  82  83  84  85  86  87   
 Message title color                   88  89  90  91  92  93  94  95   
 Normal help color                     96  97  98  99 100 101 102 103   
 Highlighted help                     104 105 106 107 108 109 110 111   
 Selected help item                   112 113 114 115 116 117 118 119   
 Help border color                    120 121 122 123 124 125 126 127   
 Help title color                      
           ͼ



The color chart appears, showing the possible color combinations and their byte
values.  At the top of the color chart are two boxes showing the old and new
byte values of the selected color type.  Use the arrow, Home, and End keys to
change the color value, noticing that the change is reflected in both the new
color value box and the Screen Colors submenu.  The status line gives a brief
explanation of how the new color value is incremented or decremented depending
on which key is pressed.  Pressing <Enter> selects the new color, while <Esc>
restores the original window colors.

When all the program color types are changed to your liking, press <Esc> to exit
the Screen Colors submenu.  The menu and message colors are changed immediately.
A submenu appears asking whether you want the text color changes to be effective
for just the current window or for all windows.  Each window can have its own
color settings.  Pressing <Esc> changes the text color in just the current
window.

Return to the Options menu and press <T> to bring up the "Type of monitor"
submenu.  The first selection, "Color monitor," forces Pas-Ed to treat your



Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 14




video system as either color or monochrome.  Most of the time, Pas-Ed will
accurately detect the type of video system in use and adjust for it.  Some video
systems are not what they appear to Pas-Ed, however, such as a monochrome LCD
display monitor connected to a CGA display adapter (common on portable
computers).  Under such circumstances, you may find it necessary to reset this
option.

The second selection, "Suppress snow," is important only if you have an older
CGA system.  Early model CGAs display "snow" during untimed direct screen
writes, which is how Pas-Ed writes to the screen by default.  If you notice snow
on your screen, set this option on.  The resulting screen writes will be
slightly slower but free of snow.

The third selection, "43/50 rows," resets the video mode to 43 screen lines if
you have an EGA system or 50 screen lines for a VGA.  If you don't have one of
these systems, a message to that effect appears and this option can't be
enabled.  Note that 43/50 line mode can also be toggled via the <Alt-V> hot key.

The fourth selection, "standard Rows," switches between 25 and 28 rows as the
standard screen size.  Your computer must be in 28 row mode to display 28 lines
on your screen; otherwise, you're prevented from enabling this option.



The User Utilities


From the Options menu, press <N> for Name User Utilities.  The Name User
Utilities submenu appears, which allows you to enter the names of five programs
which can be run from the menu system via the File/Utility selection.  The
programs may be any executable or batch files, and are run in a DOS exec session
similar to the compile, debug, and run sessions.  Pas-Ed will either swap itself
out of memory or compress the heap depending on the Options/Memory Usage submenu
settings.

Either an ".EXE," ".COM," or ".BAT" extension is necessary for proper operation
of the utilities, and Pas-Ed will append ".EXE" to any file name entered without
an extension or without one of the above extensions.  For example, if C:\PAS-ED
was the current directory and you entered

     READ.ME

Pas-Ed would return the file name

     READ.EXE

To prepend one of the three logical directories (the current directory, the
Pas-Ed directory, and the EXE & TPU directory), use the <Alt-P> Path command
to switch between the logical directories.  To enter the project file, use the
<Alt-N> Name command to change the file name.



Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 15




Next the command line for the utility is edited.  The command line is passed to
the utility when it's run, and each utility has a separate command line.

After you've edited the user utilities and their command lines, press <Esc> to
return to the Options menu.  The last selection on the Options menu is the
"editor status Line" option.  When enabled, the status line is displayed across
the bottom row of the screen in the editor; when disabled, the bottom line is
used for editing.  This option doesn't affect the display of the status line in
the menu system.  You might wish to leave this option enabled until you become
familiar with the Pas-Ed editor.



Setting Up The Macros


Press <Alt-M> to open the Macros menu.  Macros are on by default.  If you don't
wish to use macros, turn macro processing off by pressing <T> for "Turn on/off."
If you do use macros, you may want to reset the macro playback delay via the
Macro Delay selection.  This option controls the number of milliseconds paused
between keystrokes when a macro playback is in progress.  The default is 0.



Setting Up The Files


Press <Alt-L> to open the Language menu, then <F> to open the "Files" submenu.
The "Files" submenu contains the file names and command lines Pas-Ed will use
during DOS shells and compile and debug sessions.  You may enter any compiler,
compiler configuration, or debugger file names (of course, they should correctly
name an appropriate program or file).  The default names are TPC.EXE for the
compiler, TPC.CFG for the compiler configuration file, and TD.EXE for the
debugger.  As with all menu options, the names are saved in the PAS-ED.CFG
configuration file and restored at startup.

The "deBugger commands" option allows you to edit a command line which is passed
to Turbo Debugger when initiating debug sessions.  The Turbo Debugger command
line options are explained in detail in your Turbo Debugger manuals.  One common
use to this option is to pass source code and EXE/TPU directories to Turbo
Debugger.  If you don't wish to pass a command line to the debugger, leave this
line blank.

The "Run command line" option allows you to edit a command line which is passed
to the program being run (via the Run selection on the main menu).  This is
useful for passing test parameters to programs.  This command line is also
passed to programs being debugged.  If you don't wish to pass a command line to
the program, leave this line blank.

Check these options to be sure they're correct, and change them if necessary.



Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 16




Setting Up Turbo Pascal


Press <Esc> to return to the Language menu.  The first selection on the Language
menu, "Compiler," sets the Turbo Pascal compiler switches.  The second option,
"Linker," sets the Turbo Pascal linker switches.  The "Directories" selection
determines the directories where Turbo Pascal will look for the various files it
needs during compilation and where the resulting compiled files will be placed.
These options are the same as those in the Turbo IDE, and you should refer to
your Turbo Pascal manuals and Chapter 5 - The Pas-Ed Menu System if you need
further information.



Ready To Go


Pas-Ed is now ready to run.  If you're familiar with the Turbo IDE, you should
be able to run Pas-Ed with little problem.  For an overview of running Pas-Ed,
please read the next chapter, Chapter 4 - A Tour of  Pas-Ed.

































Chapter 3 - Setting Up Pas-Ed                            Pas-Ed Manual - Page 17




                         Chapter 4 - A Tour of Pas-Ed
                         



Getting Ready


This chapter illustrates most of Pas-Ed's main features in tutorial fashion.

If you're in Pas-Ed, make sure the Options/Config Auto Save menu option is on,
then exit Pas-Ed by pressing <Alt-X>.  <Alt-X> works from anywhere in Pas-Ed
except the pop-up edit windows.  Once you've exited Pas-Ed and are at the DOS
prompt, type "PAS-ED" to restart Pas-Ed.



Restoring Your Setup


Since you created a PAS-ED.CFG configuration file when you exited Pas-Ed, Pas-Ed
automatically restores your previous menu settings and colors, then loads the
files you were editing and repositions the cursor in each file to where it was
when you exited Pas-Ed.

Had you passed file name(s) to Pas-Ed as command line parameters, Pas-Ed would
load those files instead of your previous files, using ".PAS" as the default
extension.  To try this, exit Pas-Ed by pressing <Alt-X>, then type

     pas-ed file1 file2 file3.asm

at the DOS prompt.  Instead of loading your previous files, Pas-Ed loads
FILE1.PAS, FILE2.PAS, and FILE3.ASM.  If you specify more files than can fit
into available memory, Pas-Ed will load as many files as possible.



The Editor


As soon as the files are loaded, Pas-Ed places you in the editor.  The editor
uses the WordStar command set, and is virtually identical to the editor in the
Turbo IDE.  Try typing a few lines to get a feel for it.  If you forget an
editing command, press <F1> to bring up the help window.

One of the most useful and overlooked editing commands is the undo line change
command.  Move up or down a line, type some changes, then type <Ctrl-Q><L> (for
Quick-Line).  The line is restored to its original form.  This command works as
long as you haven't erased or moved off the line.




Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 18




The top line of the edit window shows the state of the editor and is explained
in greater detail in Chapter 6 - The Pas-Ed Editor.  For now, try pressing the
Caps Lock, Num Lock, and Scroll Lock keys and note how they affect this line.

The status (or bottom) line shows, from left to right, the window number, the
commands associated with the function keys, and the location of the edit buffer
for the active window ("DOS" or "EMS").

Now press <F2> to save the file.  <F2> immediately saves the file unless the
Options/Edit File Save menu option is set to Browse, in which case you must
verify the file save before Pas-Ed will save the file.

Press <F4> to open a new window.  The File Name window reappears, only this time
the file you specify will be loaded into a new window.  The new window number is
visible in the lower left corner of the screen.  This number always shows the
window number of the file being acted upon.  Enter a file name and the window
will be created and the file loaded.

Note that, if you're editing the same file in two different windows, you're
actually editing two separate copies of the file, and changes made in one window
aren't being made to the text in the other window.

<Alt-F4> performs the opposite function of <F4> and closes the current window.
Press <Alt-F4>, and the current window is closed and its memory deallocated.  If
the file in the window has been changed, it's saved before the window is closed
according to the setting of its Options/Edit File Save parameter.  Press <F4>
and reopen the window.

Press <F3> to load a new file, entering a name into the File Name window.  If
it's a new file, Pas-Ed verifies that you actually wanted to create a new file
and didn't just make a typing mistake.

<Alt-F3> also switches files but uses the Memory-Files Pick list.  This Pick
list contains the names of all the files currently loaded in memory.  Press
<Alt-F3> the see the list, then choose a file.  Pas-Ed immediately switches to
the selected file.

<Ctrl-F3> switches files as well but uses the Recent-Files Pick list.  This Pick
list contains the names of the last ten files you've edited, with the most
recent files at the top of the list.  File names are not duplicated on the list;
if you jump to a file which was half way down the Pick list, the file name is
simply moved to the top of the list.  For now, select a file that's not
currently in memory, and Pas-Ed will reload the file into the current window and
reposition the cursor to where it was when you exited the file.

Press <F5> and the active window is reduced to half screen (unzoomed).  Press
<F5> again and the window is restored to full screen (zoomed).

Now press <F6> several times to rotate through the open windows.  Similarly,
press <Alt-F6> to rotate backwards through the windows.



Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 19




Type something and mark a block in each window.  (<Ctrl-K><B> marks the
beginning of a block and <Ctrl-K><K> marks the end.)  Using the F5 and F6 keys,
switch and zoom/unzoom the windows until both windows and blocks are visible on
the screen.  Press <Ctrl-K><C> to copy the block in the active window to the
cursor position.  Now press <F7> and copy the block from the other window to the
cursor position.  Move the cursor and press <Ctrl-K><V> to move the block in the
active window to the cursor position.  Now press <F8> and move the block from
the other window to the cursor position.  Note that both <F7> and <F8> can copy
and move blocks from any window, including the current window, and will also
copy and move the block regardless of whether it's highlighted (^KH switches
block highlighting).

If your printer is connected to the LPT1 parallel printer port 1 and turned on,
use <Ctrl-K><P> to print the block in the active window.

Type a nonsense word to ensure the file won't compile properly.  Press <F9> to
make (compile) the file.  Pas-Ed will either swap a DOS memory image to EMS/disk
or compresses the heap depending on the setting of the Options/Memory Usage
submenu, then call the compiler to compile the file.  If you get an out of
memory message, change the Options/Memory Usage/Swap To EMS/Disk menu setting to
on, then recompile the file.  The compiler will find the error, and Pas-Ed will
automatically load and/or switch to the file with the error, then position the
cursor at the source of the error, highlight it, and display the error message.
Pressing the <Alt-D> hot key to clear the error message and select the Debug
option.



Switching Exec Files and Directories


Pas-Ed automatically loads the file name from the current window as the file to
debug.  Now switch the file name between the file in the active window and the
project file by pressing <Alt-N> (for Name).  This command works in the Compile,
Debug, and Run File Name windows, and when entering the name of a user utility.

Let's assume you're using the DOS path to run Pas-Ed, and your Pas-Ed files are
in one directory, you've started Pas-Ed from a second directory, and your EXE
and TPU files are in a third directory via the Language/Directories/EXE & TPU
Directory menu setting.  How do you switch between the three directories without
typing in a complete path name every time you compile, run, or debug a program?
Pas-Ed provides a simple solution.

Let's assume the directory shown isn't the correct directory.  Instead of typing
in a new path, press <Alt-P> (for Path), and Pas-Ed automatically switches the
path name between the three logical paths.

The <Alt-P> command works in the Compile, Debug, and Run File Name windows, and
when entering the name of a user utility.




Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 20




To see the last DOS screen, press <Alt-F1>.  The screen is cleared by pressing
any key.  This option is especially useful to review compiler error messages
when using Pas-Ed to write programs in other languages, such as when writing
assembler routines.



The Window Menu


Press <Alt-W> to open the Window menu.  Press <H> to hide the active window.
Now press <Alt-E> to return to the editor, then <F6> several times to rotate
through the windows and verify that the window has been hidden.  Press <Alt-W>
to reopen the Window menu, then <U> for Unhide.  A menu appears with a list of
all the hidden windows, and you can either pick one to unhide or press <Esc> to
cancel.  Press <Esc> to cancel, then <M> for M-Pick.  The Memory-Files Pick list
appears, with hidden windows clearly marked as such and the active window
prefaced by "".  This Pick list selects a new active window.  Select the hidden
window as the new active window, and it is immediately unhidden and becomes the
active window.  Verify that the window is unhidden by using <F6> to rotate
through the windows.  Note that the Memory-Files Pick list is also available via
the <Alt-F3> hot key.

Press <Ctrl-F3> and the Recent-Files Pick list appears, displaying the ten most
recently edited files.  This Pick list is also available via the File/R-Pick
menu option, and will jump into and unhide hidden windows.

From the Window menu, press <C> for Close, and the active window is closed and
removed from memory.  Now try to close the remaining windows, and Pas-Ed will
prevent the last window from begin closed.  At least one window must always be
open.  Press <O> and reopen the closed windows.  Now close and reopen the window
using the <Alt-F4> and <F4> hot keys.

The remaining entries on the Window menu rotate forward and backward through the
file rotation and zoom and unzoom the windows, similar to the F5 and F6 keys in
the editor.



The Search Menu


Press <Alt-S> to open the Search menu.  This menu enables you to search and move
quickly through the files.  The Find and Replace menu selections are the same as
the <Ctrl-Q><F> (Quick Find) and <Ctrl-Q><A> (Quick Find and Replace) WordStar
commands.  The Find Next and Replace Next menu selections are the same as
Wordstar's <Ctrl-L>.  The Find Block and Replace Block menu selections load the
search string with up to 30 characters from the marked block in the active
window, although not across line breaks.  Since there's a marked block in the
active window, press <I>, then <E> from the Search menu to try these selections.



Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 21




From the Search menu, press <G> for Goto line.  Enter a line number and Pas-Ed
jumps to the specified line.  If the line number is greater than the number of
lines in the file, Pas-Ed jumps to the end of the file.

Press <S> to set a placemarker.  You have ten placemarkers, 0-9.  Press <5> to
set placemarker 5 at the current cursor position in the current file.  The
placemarkers don't have to be set in any particular order.  Press <Alt-W> to
open the Window menu and <N> to rotate to the next window.  Then press <Alt-S>
to open to the Search menu, <J> for Jump To Placemarker, then enter <5>.  Pas-Ed
jumps to the proper file and line number.  These commands are also available
from the editor.  Press <F6> to rotate to the other file.  Press <Ctrl-K><1> to
set placemarker 1, then jump back and forth between the two files by pressing
<Ctrl-Q><5> and <Ctrl-Q><1>.



The Macro Menu


Press <Alt-M> to open the Macro menu.  Through this menu, Pas-Ed can record and
playback keystrokes.  The Macro menu is fairly self-explanatory, and you should
have no trouble using the macros.  For good measure, though, we'll record, edit,
and delete a macro.

Press <R> to record a macro.  A message appears reminding you how to turn macro
recording off.  Press <Esc> to clear the message, then <Alt-E> to enter the
editor.  Notice the "M" next to the window number in the lower left corner of
the screen, indicating that macro recording is on.  Typing carefully (trust us),
type the letter "c", no more, no less, then press <Alt-F10> to turn macro
recording off.   Pas-Ed asks for a key to associate the macro with.  Enter
<Alt-B>, then enter "Bad Macro" as the name for the macro.

Try out the macro by pressing <Alt-B>.  Instead of inserting "c" into the file,
the Compile menu opens.  To see why, press <Alt-M> to open the Macro menu, then
<E> to edit a macro, and choose "Bad Macro" as the macro to edit.  Press <Enter>
to accept the macro name, and the Edit Macro window appears with Bad Macro
displayed.  The macro should be shown as "<AltE>c".  As you can see, all
keystrokes after macro recording was turned on were faithfully recorded,
including keystrokes that perhaps we didn't want, such as the <Alt-E> command we
used to return to the editor.  When we started Bad Macro by pressing <Alt-B>,
Bad Macro first selected the Edit menu with <Alt-E>, then selected the Compile
menu with <c>.  You should edit all macros after they've been recorded to remove
unwanted keystrokes.

While still in the Edit Macro window, press the Home and End keys.  Instead of
moving the cursor to the beginning and end of the line, <Home> and <End> are
inserted into the macro.  In order to use these keys to maneuver around the Edit
Macro window, you must use the <Scroll Lock> key to toggle between command and
literal interpretation.  Try out the macro editor, in particular noticing how




Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 22




the extended keys, such as Home, End, Insert, Delete, Backspace, etc., are
handled depending on whether the editor is in Command or Literal mode.

Use the <Scroll Lock> key to be sure you're in Command mode, then either press
<Enter> to accept the edited macro or <Esc> to restore the original macro.  Then
press <D> for Delete, and delete Bad Macro.



The Other Menus


The other menus are concerned mostly with setting up and running Pas-Ed and
Turbo Pascal.  The selections are either easily understood by programmers
familiar with Turbo Pascal or are explained in Chapter 3 - Setting Up Pas-Ed,
Chapter 5 - The Pas-Ed Menu System, or in your Turbo Pascal manuals.



The Pop-up Tables


Two of Pas-Ed's handiest features are the pop-up ASCII and extended key code
tables, which will save you the considerable time and trouble most programmers
spend looking up this information.  Press <Alt-E> to return to the editor, then
<Alt-A> to bring up the ASCII table, and <Alt-K> to bring up the extended Key
code tables.



Switching Video Modes


Press <Alt-V> to switch between standard and 43/50 screen line modes.  If your
display has 43/50 line capability, it's immediately switched into 43/50 line
mode; otherwise, a message informing you that your display doesn't have this
ability appears.  If your video display mode was successfully switched, press
<Alt-V> to switch it back.  This command is available from anywhere in Pas-Ed
except the pop-up edit windows.














Chapter 4 - A Tour of Pas-Ed                             Pas-Ed Manual - Page 23




                      Chapter 5 - The Pas-Ed Menu System
                      



About the Menus


Pas-Ed's menus are similar in style to those in the Turbo IDE.  The main menu
displays horizontally across the top row of the screen, with pull-down submenus
opening vertically below.  All selections on the main menu are "hot keyed" and
can be selected from anywhere in Pas-Ed (except from the pop-up message windows,
which require a specific response such as <Y>, <N>, or <Esc>) by holding down
the <Alt> key and pressing the first letter of the selection. For example, to
open the File menu, press <Alt-F>, and to select Run, press <Alt-R>.

Moving around the menu system is accomplished by using either the dedicated
movement keys, such as the arrow, Home, and End keys, or WordStar commands, such
as <Ctrl-S> for left, <Ctrl-D> for right, <Ctrl-E> for up, <Ctrl-X> for down,
etc.  Pressing <Enter> or <Ctrl-M> when the light bar is over a selection or
pressing its highlighted letter selects it.  Pressing <Esc> or <Ctrl-[>
deselects or closes a menu.

To assist you in choosing the proper menu options, each individual selection has
a brief descriptive prompt displayed in the status line.



The Menu Selections


This section describes the operation and function of each menu selection.  The
menu selections are:

File

Displays the File menu.  The File menu selections are:

     Load
     
     Loads a file into the active window.  If the requested file is already
     loaded in another window, you're given the choice of either switching to
     that window or going ahead and loading the file into the active window.
     The file which was already in the window is saved according to the setting
     of the window's Edit File Save toggle (see the Options menu).  The Load
     option can also be selected from the editor by <F3>.

     R-Pick
     
     Displays the Recent-Files Pick list (a list of the ten most recently edited



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 24




     files) and allows you to select one to edit.  If the selected file isn't in
     memory, the file will be loaded into the active window and the cursor
     repositioned to where it was when the file was last being edited.  If the
     selected file is in memory, Pas-Ed will switch to the window containing the
     file even if the window is hidden.  If the window was hidden, it remains
     hidden; as soon as you leave the window, it's removed again from the window
     rotation.  This option can be selected from the editor by <Ctrl-F3>.

     Clear
     
     Deletes all data from the active window without saving and resets the file
     name to a default PAS-xxxx.PAS name.  You're asked to confirm this action.

     Save
     
     Immediately saves the file in the active window unless the Edit File Save
     toggle is set to Browse, in which case you're asked to confirm the save.

     save All
     
     Saves all changed files according to the setting of their window's Edit
     File Save toggles.

     Write to
     
     Writes the file in the active window to a file you specify.

     Dir
     
     Display a directory based on a directory mask you specify.

     New Dir
     
     Changes the current directory.  Note that the current directory cannot be
     changed in a DOS shell, as Pas-Ed switches back to the current directory
     after the DOS shell is completed.

     OS shell
     
     Runs the DOS command you specify.  If no command is given, the screen is
     cleared and the DOS prompt appears.  Pas-Ed is re-entered by typing "EXIT"
     at the DOS prompt.  If EMS/disk swapping is enabled, the contents of memory
     are swapped out to EMS or disk prior to the DOS shell; otherwise, the heap
     is compressed and the shell is run with whatever DOS memory is available.

     Utilities
     
     Displays the User Utilities submenu and runs the user utility you specify.
     Pas-Ed allows you to enter five utility names and command lines into the




Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 25




     menu system via the Options/Name User Utilities selection.  These utilities
     must be valid EXE, COM, or BAT files and must be located either in the same
     directory as Pas-Ed or on the DOS path or have a full path included.  These
     five utilities can then be run as part of the Pas-Ed IDE.  When run, if
     EMS/disk swapping is enabled, the contents of memory are swapped out to EMS
     or disk and the utility is run; otherwise, the heap is compressed.

     Exit
     
     Exits Pas-Ed and returns to DOS.  The files being edited are saved
     according to their window's Edit File Save toggles.  If the Config Auto
     Save and/or Macro Auto Save toggles are on, the configuration and/or macro
     files are saved.  See the Options menu for an explanation of these toggles.
     This option can be selected from anywhere in Pas-Ed except the pop-up
     message windows by pressing <Alt-X>.


Window

Displays the Window menu.  The Window menu selections are:

     Open
     
     Opens a new edit window if sufficient memory is available.  Windows are
     allocated first in DOS memory, then in EMS memory.  Up to 21 windows may be
     opened.  This option is available from the editor by <F4>.

     Close
     
     Closes the active window and deallocates it memory.  If the file in the
     active window has been changed during the editing session, it's saved
     according to the setting of the window's Edit File Save toggle (see the
     Options menu).  This option is available from the editor by <Alt-F4>.

     M-Pick
     
     Displays the Memory-Files Pick list (a list of all files loaded in the
     windows) and allows you to select one as the active window.  If the
     selected window is hidden, it is unhidden.  This option is available from
     the editor by <Alt-F3>.

     Next
     
     Selects the next unhidden window as the active window.  This option is
     available from the editor by <F6>.

     Back
     
     Selects the previous unhidden window as the active window.  This option is
     available from the editor by <Alt-F6>.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 26




     Zoom
     
     Resizes the active window to either full screen (zoomed) or half screen
     (unzoomed).  Note that at least one window must always be zoomed.  This
     option is available from the editor by <F5>.

     Hide
     
     Hides the active window.  The data in the hidden window remains intact and
     the file save routines operate normally.  The window is simply removed from
     the window rotation.  This is useful if, for example, you have all 21
     windows open but are editing only 3 files; this option allows you to hide
     the other 18 windows.  Hidden windows may be unhidden with either the
     Window/Unhide or Window/M-Pick commands.  Note that at least one window
     must be unhidden.

     Unhide
     
     Displays a list of all hidden windows and allows you to select one to
     unhide.


Edit

Erases the menus, displays the active window, and calls the editor.


Search

Displays the Search menu.  The Search menu selections are:

     Find
     
     Finds the search string using the search options you specify.

     fInd block
     
     Loads the search string with up to 30 characters from the marked block in
     the active window.  Characters are not loaded across line breaks.

     fiNd next
     
     Finds the next occurrence of the search string using the previous search
     options.

     Replace
     
     Finds the search string and replaces it with the replacement string using
     the replace options you specify.




Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 27




     rEplace block
     
     Loads the search string with up to 30 characters from the marked block in
     the active window.  Characters are not loaded across line breaks.

     rePlace next
     
     Finds the next occurrence of the search string and replaces it with the
     replacement string using the previous replace options.

     Goto line
     
     Moves the cursor to the line number you specify.

     Set marker
     
     Sets the placemarker you specify (0 to 9) to the current cursor position in
     the current file.

     Jump to marker
     
     Jumps to the placemarker you specify (0 to 9) even in the file containing
     the placemarker has been moved to disk or if the file is now in a different
     window from the window where the placemarker was set or if the window
     containing the file is hidden.  Jumping into a hidden window doesn't unhide
     it; as soon as you leave the window, it's removed again from the window
     rotation.  If there are 2 windows containing the same file, Pas-Ed jumps to
     the first one.


Macros

Displays the Macro menu.  The Macro menu selections are;

     Playback
     
     Plays back the macro you specify.

     Record
     
     Begins recording keystrokes into a macro.

     record Off
     
     Stops recording keystrokes and asks for a key to associate the macro with
     as well as a name for the macro.  This is the same as pressing <Alt-F10>
     from within the editor.  After a macro has been recorded, you should edit
     the macro to remove any keystrokes associated with setting up the macro.
     Pas-Ed automatically removes the keystrokes that turned macro recording on
     and off.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 28




     Load
     
     Loads a macro file, replacing the macros in memory with the macros from the
     file.

     Merge
     
     Merges the macros from a macro file with the macros in memory.  If the
     current macro file is then saved after the merge, it will include the
     merged macros.

     Save
     
     Writes the macros in memory to the current macro file.

     list
     
     Lists the macros in memory.

     Edit
     
     Edits an in-memory macro.

     Delete
     
     Deletes an in-memory macro and deallocate its memory.

     delete All
     
     Deletes all in-memory macros and deallocates their memory.  You're asked to
     confirm this action.

     macro delaY
     
     Adjust the delay between keystrokes when a macro is played back.  The delay
     is in milliseconds and can be any number between 0 and 255.

     Turn on/off
     
     Enables and disables macro processing.  Macro processing is on by default.
     When disabled, all macros are deleted and their memory deallocated.  When
     re-enabled, the macros in the current macro file are reloaded into memory.


Compile

Displays the Compile menu.  The Compile menu selections are:

     Compile
     
     The selected file is compiled.  No other units used by the program which


Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 29




     have existing TPU files are recompiled even if their source code has been
     changed since they were last compiled.

     Make
     
     The selected file is compiled along with all units used by the program
     whose source code has changed since they were last compiled.

     Build
     
     The selected file and all units used by the program are compiled.  This
     option ensures that all TPU files are up to date.

     Production build
     
     The selected file and all units used by the program are compiled using your
     regular compiler settings, except no debug information is generated and
     stack and range checking are turned off.  This option ensures that all TPU
     files are up to date.

     Auto config file
     
     Enables and disables automatic creation of a compiler configuration file.
     When enabled, an updated compiler configuration file is written to disk
     prior to every compile; if disabled, no compiler configuration file is
     written.  The default name for the configuration file is TPC.CFG, which can
     be changed using the Language/Files submenu.

     Find error
     
     Locate the source code location of a run-time error if you have its hex
     location.  For example, a runtime range error might result in the message
     "Runtime error 201 at 3C08:023B."  By entering the hex number "3C08:023B"
     as the error location and recompiling the file, Pas-Ed will automatically
     locate and display the line in the source code that caused the error.


Run

Run a program from within Pas-Ed.  If EMS/disk swapping is enabled, a DOS memory
image is swapped out to EMS or disk prior to the program run.


Debug

Debug a program from within Pas-Ed.  If EMS/disk swapping is enabled, a DOS
memory image is swapped out to EMS or disk prior to the debug session.






Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 30




Language

Displays the Language menu.  The Language menu selections are:

     Compiler
     
     Displays the Compiler submenu, which contains the options for the Turbo
     Pascal compiler.  The Compiler submenu selections are:

          Align data
          
          Align variables and typed constants on byte or word boundaries.
          Generally, byte alignment takes less memory while word alignment runs
          faster.

          Boolean evaluation
          
          Switch between complete and short circuit boolean evaluation, which
          determines whether boolean expressions are evaluated completely or
          terminated as soon as possible.

          Conditional defines
          
          Allows you to enter conditional compilation directives which can be
          referenced in the source code.

          Debug information
          
          Displays the Debug menu.  The Debug menu selections are:

               Append debug info to EXE
               
               Enables and disables the appending of debug information to the
               compiled EXE file.  This information is necessary to use Turbo
               Debugger on your program.  The extent of the debugging
               information appended depends on the following two settings:

               Make line-number table
               
               Enables and disables the generation of a source code line-number
               table.  This table allows Turbo Debugger to step through the
               source code line by line during a debugging session.  Unless this
               option is enabled, Turbo Debugger steps through your program at
               the CPU (assembly) level.

               Include local symbols
               
               Enables and disables the generation of debug information for
               local symbols, which are the names and types of all local (as
               opposed to global) variables and constants.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 31




          Force far calls
          
          Enables and disables the use of the FAR code model by all procedures
          and functions.

          I/O Checking
          
          Enables and disables the generation of code to check for input/output
          errors.

          Memory sizes
          
          Displays the Memory Size submenu.  The selections on the Memory Size
          submenu are:

               Stack size
               
               Set the stack size in decimal bytes.

               Low heap limit
               
               Set the minimum required heap size in decimal bytes.

               High heap limit
               
               Set the maximum heap size in decimal bytes.

          Numeric processing
          
          Displays the Numeric Processing submenu.  The selections are:

               Emulation
               
               Enables and disables linking of the 8087 emulation library.  This
               library uses the 8087 math coprocessor if present and emulates it
               if not.

               Numeric processing
               
               Switches between inline 8087 code, which allows the use of
               single, double, extended, and comp real types, and the use of
               software-only (6 byte) reals.  Note that if inline 8087 code is
               enabled, you must either link in the 8087 emulation library (see
               the option above) or the computers on which the program is run
               must have an 80x87 math coprocessor.

          Overlays allowed
          
          Enables and disables the generation of overlay code.  Units compiled
          with this option on do not have to be overlayed.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 32




          Range checking
          
          Enables and disables the generation of code to check the bounds on
          arrays, strings, and scalar-type variables.

          Stack checking
          
          Enables and disables the generation of code to check for stack
          overflow.

          Var-string checking
          
          Enables and disables checking of declared string parameters against
          the actual passed parameter.  If this option is on and the declared
          and actual string parameters are not identical, a compiler error
          occurs.

     Linker
     
     Displays the Linker submenu.  The selections are:

          Link buffer
          
          Switch between using a disk or memory link buffer.  Linking to memory
          is faster but the linker may run out of memory on larger programs.
          Linking to disk is slower but larger programs can be linked.

          Map file
          
          Sets the amount of information that goes into the map file (typically
          used by 3rd party debuggers).  The selections are:

               None
               
               No map file is generated.

               Segments
               
               Only segment information is generated.

               Publics
               
               Segment information plus all symbol names and addresses and the
               location of the program's entry point are generated.

               Detailed
               
               Publics information plus line-number and module tables are
               generated.




Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 33




     Directories
     
     Displays the Directories submenu, which contains the paths to the various
     files needed by the Turbo Pascal compiler.  The Directory submenu
     selections are:

          Turbo directory
          
          The compiler will search the current directory and the directory
          specified here for the TURBO.TPL compiler library file.

          EXE & TPU directory
          
          The compiler will put the compiled EXE and TPU files in the directory
          specified here.  If no directory is specified, the compiled files will
          go in the directory with the source code file.

          Include directories
          
          The compiler will search the current directory and the directories
          specified here for the files listed with the Include {$I Filename}
          compiler directive.

          Unit directories
          
          The compiler will search the current directory and the directories
          specified here for units used by the files being compiled.

          Object directories
          
          The compiler will search the current directory and the directories
          specified here for the object files listed with the {$L Filename}
          compiler directive.

     Files
     
     Displays the Files submenu, which contains the names of the various files
     called by Pas-Ed during operation.  The Files submenu selections are:

          Compiler file name
          
          The file Pas-Ed will call to compile files.  ".EXE" is the default
          extension, and any file name you enter without an extension will have
          ".EXE" appended to it.

          conFigure file name
          
          The compiler configuration file.  This is the file Pas-Ed will write
          the Turbo Pascal compiler and linker switches to if the Auto Config
          File option is enabled (see the Compile menu).  ".CFG" is the default
          extension.


Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 34




          Debugger file name
          
          The file Pas-Ed will call to debug files.  ".EXE" is the default
          extension.

          deBugger commands
          
          The command line passed to the debugger.  As an example, this option
          would allow you to pass a list of source and EXE/TPU directories to
          Turbo Debugger.  For more information on the command line options
          offered by Turbo Debugger, consult your manuals.

          Run command line
          
          The command line passed to the program being run via the Run selection
          on the main menu.  As an example, this option would allow you to pass
          command line test parameters to the program being run.

          Pas-Ed config file
          
          The Pas-Ed configuration file.  The default file name is PAS-ED.CFG
          and cannot be changed.  This file is stored by default in the same
          directory as PAS-ED.EXE, although Pas-Ed will find the file in any
          directory as long as it's on the DOS path.

          Macro file name
          
          The name of the currently loaded macro file.  This file can be changed
          using the Macro/Load menu option.


Options

Displays the Options menu.  The Options menu selections are:

     Config auto save
     
     Enables and disables automatic saving of the PAS-ED.CFG configuration file
     upon exit.  This file contains a description of Pas-Ed's last setup.  At
     startup, Pas-Ed looks for this file in the Pas-Ed directory and uses it to
     restore colors and menu settings and reload the files you were last using.

     Edit file save
     
     Switches between automatic, prompted, and Browse file save status.  If set
     to Auto, the file is automatically saved if it has been changed during the
     editing session.  If set to Prompt, you're prompted whether or not to save
     the file.  If set to Browse, the file isn't saved and you're not prompted.
     You're given the choice of applying the new setting to just the active
     window or to all windows.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 35




     Backup files
     
     Enables and disables the creation of backup files when saving your source
     code files.  You're given the choice of applying the new setting to just
     the active window or to all windows.

     Macro auto save
     
     Enables and disables automatic saving of the macro file when exiting.

     Write config file
     
     Writes the PAS-ED.CFG configuration file to disk using the current
     settings.

     memory Usage
     
     Displays the Memory Usage submenu.  The selections are:

          Swap to EMS/Disk
          
          Enables and disables swapping of a DOS memory image to expanded memory
          (EMS) or disk prior to a DOS shell or a compile, debug, or run
          session.  If enabled, more memory is freed up than would otherwise be
          available; however, this must be balanced against the time penalty
          imposed by the swap.  On systems with EMS memory, the time penalty is
          minimal and this option can be left enabled.  Systems requiring disk
          swaps, and in particular swaps to a floppy disk, might want to disable
          this option during simple DOS shells, providing enough DOS memory is
          available for the exec session.

          Reserve EMS for swap
          
          Enables and disables the reservation of enough EMS memory to hold a
          DOS memory swap.  If enabled, enough 16k (16,384 byte) blocks of EMS
          memory are set aside for the swap.

          Working memory
          
          Sets the amount of DOS memory reserved by Pas-Ed for internal purposes
          such as screen saves, macros, EMS-to-EMS block moves, etc.  By
          adjusting this value, sufficient memory can be reserved to allow
          proper functioning of the program while leaving as much memory as
          possible for the edit buffers.  The default value is 20,000 bytes, and
          may be changed to any value between 16,384 and 65,535.

          If you encounter memory allocation failure messages, simply increase
          this number and then exit and restart Pas-Ed.





Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 36




          DOS buffers open
          
          Displays the number of edit windows opened in DOS memory.

          EMS buffers open
          
          Displays the number of edit windows opened in EMS memory.

          Total buffers open
          
          Displays the total number of open windows.

          Edit buffer size
          
          Displays the size in bytes of the edit buffers (all edit buffers are
          the same size).

          EMS/Disk Swap Size
          
          Displays the exact size in bytes of the DOS memory swap.

          EMS reserved for swap
          
          Displays the amount of expanded memory (EMS) reserved for the DOS
          memory swap.  Since EMS memory is allocated in 16k (16,384 byte)
          blocks, this figure has been rounded up to the next 16k block unless
          by coincidence your memory swap size is exactly divisible by 16k.

          Dos Memory Available
          
          Displays the amount of available DOS memory.

          Ems Memory Available
          
          Displays the amount of available EMS memory.

     Screen colors
     
     Displays the Screen Colors submenu, which allows you to change the screen
     colors.  The functioning of the Screen Colors submenu is explained in
     detail in Chapter 3 - Setting Up Pas-Ed.

     The types of screen colors fall into 5 general categories:

          Text colors
          
          There are four text color types: Normal, Highlighted, Marked Block,
          and Error, which are the colors used when displaying the editing
          windows.  Normal is the regular text color, Highlighted for the
          message line, Marked Block for marked blocks, and Error for error
          messages.


Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 37




          General screen colors
          
          There are two general screen color types: Screen Background and Status
          Line.  Screen Background is used when not in the editor or menu
          systems, such as during DOS shells, compiles, etc.  Status Line is
          used for the bottom row of the screen except for the function key
          displays, which use Menu Highlighted.

          Menu colors
          
          There are five menu color types: Normal, Highlighted, Selected,
          Border, and Title.  Normal is the regular menu color, Highlighted for
          selection letters, Selected for the moving light bar, Border for the
          menu border, and Title for menu headers.

          Message colors
          
          The five message color types are the same as the five menu colors
          types except they're used to display general messages.

          Help colors
          
          The five help color types are the same as the five menu colors types
          except they're used to display help messages.

     Default screen colors
     
     Resets the screen colors to their default values.  You're asked to confirm
     this action.  You have the choice of restoring the default colors in just
     the active window or in all windows.  Pressing <Esc> changes the colors in
     just the current window.

     Type of monitor
     
     Displays the Monitor submenu.  The selections are:

          Color monitor
          
          Forces Pas-Ed to treat your video display as either color or
          monochrome.

          Suppress snow
          
          Suppresses snow on older CGA displays at the expense of somewhat
          slower screen writes.

          43/50 rows
          
          Allows EGA/VGA systems to display 43/50 screen rows respectively.  The
          default is 25 rows.



Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 38




          standard Rows
          
          Switches between using 25 and 28 rows as the standard screen display.
          Your computer must be in 28 screen line mode for this option to take
          effect; otherwise, it does nothing.

     View last DOS screen
     
     Displays the last DOS screen, which would be either the screen when Pas-Ed
     was started or the screen during a DOS shell or a compile, debug, or run
     session.  This option is particularly useful to view compiler errors.

     Name user utilities
     
     Displays the Name User Utility submenu, which allows you to enter the names
     and command lines of the five user-selected utilities.  These utilities can
     then be run from the File/Utility menu selection.

     editor status Line
     
     Switches between using the bottom screen row in the editor for the status
     line or an editing line.































Chapter 5 - The Pas-Ed Menu System                       Pas-Ed Manual - Page 39




                         Chapter 6 - The Pas-Ed Editor
                         



About the Editor


Turbo Pascal programmers should have little trouble adapting to Pas-Ed's editor,
as it uses the same command set as the Turbo IDE.  Pas-Ed's windows operate much
like Sidekick's, and on-line help is available through the <F1> key.

Because of the editor's similarity to the Turbo IDE editor, and since Pas-Ed
users are assumed to be familiar with Turbo Pascal and to have the Turbo Pascal
manuals, the description of the editor is brief.



The Editor Message Line




      Line 1    Col 1   Insert Indent Tab D:TESTFILE.PAS  Scr Num CAP BAK Auto



Above is an example of the editor message line, which appears at the top of each
text window and shows the status of the editor for that particular window.  Each
window can have different settings except for the keyboard status toggles, which
are the same for all windows.  The message line entries are:

     Line             The line number on which the cursor is located.

     Col              The column number in which the cursor is located.

     Insert           If visible, indicates that characters are being inserted
                      into the text buffer.  If off, characters are overwriting
                      the existing text.  This option is toggled by <Ctrl-V> or
                      <Insert>.

     Indent           If visible, indicates that new lines will be indented to
                      the level of the line above.  If off, new lines start at
                      Column 1.  This option is toggled by <Ctrl-Q><I>.

     Tab              If visible, indicates that fixed, 8-column tabs are
                      enabled.  If off, tabs are set at the first letter of the
                      words on the line above.  This option is toggled by
                      <Ctrl-O><T>.




Chapter 6 - The Pas-Ed Editor                            Pas-Ed Manual - Page 40




     D:TESTFILE.PAS   The name of the file being edited.  Note that the full
                      path name is not displayed.

     Scr              If visible, indicates that the Scroll Lock key is on.

     Num              If visible, indicates that the Num Lock key is on.

     CAP              If visible, indicates that the Caps Lock key is on.

     BAK              If visible, indicates that a backup file will be made when
                      the file in the active window is saved.

     Auto             Displays the status of the Options/Edit File Save menu
                      option.  If "Auto" is displayed, then the file in the
                      active window will automatically be saved.  "Prompt" means
                      you'll be prompted whether or not to save the file, and
                      "Browse" means the file won't be saved and you won't be
                      prompted.



The Editor Status Line




2M   F1Help F2Save F3Load F4Open F5Zoom F6Next F7Copy F8Move F9Make F10Menu  DOS



Above is an example of the editor status line.  From left to right, the "2"
indicates that the number 2 edit window is active.  The "M" next to the "2"
means that macro recording is on.  In the middle are the function keys along
with a keyword description of their function.  The "DOS" on the far right
indicates that the active window has been allocated in DOS memory.  If the
active window had been allocated in EMS memory, "EMS" would be displayed.

The editor status line can be toggled off and the bottom row recovered for
editing via the Options/Editor Status Line selection.



The Function Keys


The functions assigned to the function keys are:

     <F1>      - Help.
                 Displays a help menu, from which the various editing commands
                 can be displayed.



Chapter 6 - The Pas-Ed Editor                            Pas-Ed Manual - Page 41




     <Alt-F1>  - View last DOS screen.
                 Displays the last DOS screen.  Pressing any key clears the
                 screen.

     <F2>      - Save.
                 Saves the file in the active window to disk.

     <F3>      - Load.
                 Loads a new file into the active window.

     <Alt-F3>  - Memory-Files Pick list.
                 Displays a list of the files in memory and allows you to choose
                 one as the active window.

     <Ctrl-F3> - Recent-Files Pick list.
                 Displays a list of the ten most recently edited files and
                 allows you to choose one to edit.  If the chosen file is in
                 memory, Pas-Ed switches to the window containing the file.  If
                 the file isn't in memory, Pas-Ed will load it into the current
                 window.

     <F4>      - Open.
                 Opens a new edit window if enough memory is available.

     <Alt-F4>  - Close.
                 Closes the active window and deallocates its memory.

     <F5>      - Zoom.
                 Resizes the active window to full or half screen.

     <F6>      - Next.
                 Selects the next unhidden window as the active window.

     <Alt-F6>  - Back.
                 Selects the previous unhidden window as the active window.

     <F7>      - Copy.
                 Displays a pop-up menu showing the files with marked blocks.
                 The block from the selected file is copied into the active
                 window at the cursor location.  This option is identical to the
                 <Ctrl-K><C> block copy command except that it can also copy
                 between files.

     <F8>      - Move.
                 Displays a pop-up menu showing the files with marked blocks.
                 The block from the selected file is moved into the active
                 window at the cursor location.  This option is identical to the
                 <Ctrl-K><V> block move command except that it can also move
                 between files.




Chapter 6 - The Pas-Ed Editor                            Pas-Ed Manual - Page 42




     <F9>      - Make.
                 Makes (compiles) the file in the active window.

     <F10>     - Menu.
                 Opens the menu system.  This option is the same as <Alt-E>.

     <Alt-F10> - Macro recording off.
                 Turns macro recording off.



Entering Text


Text is entered into the Pas-Ed editor in a fashion similar to the Turbo IDE.
Like the IDE, Pas-Ed doesn't wrap lines, and lines must be terminated with
<Enter>.  As long as the cursor hasn't been moved from the line being edited and
the line hasn't been erased, the original line can be restored with <Ctrl-Q><L>.
If the Insert toggle is on, characters are inserted into the text buffer;
otherwise, characters overwrite the existing text.

The Pas-Ed editor is a WordStar command editor.  The Turbo Pascal manuals have a
good explanation of the editing commands.  If you need a quick reference of the
commands, press <F1> from within the editor to bring up the help menu.  If you
need a quick reference of the ASCII or extended key codes, press <Alt-A> for a
pop-up ASCII table and <Alt-K> for an extended key code table.



























Chapter 6 - The Pas-Ed Editor                            Pas-Ed Manual - Page 43




                       Chapter 7 - Hints On Using Pas-Ed
                       



Hint:   Pas-Ed's text buffers are completely independent of one another.  If
        you've loaded the same file into two windows, remember you aren't
        editing the same text in two windows but rather two separate text
        buffers.  Changes made to the text in one window aren't being made to
        the text in the other window.  If you make different changes in each
        window and save both windows, the file on disk will contain the changes
        made to the last window saved.


Hint:   When working on multi-file programs, always load the main program as the
        project file.  That way, you can compile, run, or debug the program from
        any window by using a macro which starts the session and enters <Alt-N>
        in the File Name window.  For example, the following macro will make the
        project file:

             <Alt-C><M><Alt-N><Enter><Enter>

        This macro opens the Compile menu with <AltC>, selects Make with <M>,
        uses the <Alt-N> Name hot key to switch the file name to the project
        file, <Enter> to select the project file as the file to compile, and
        <Enter> to accept the compiler command line and start the compile.


Hint:   Although you can record macros which operate across DOS shells and
        compile, debug, and run sessions, it's usually best not to write them
        unless you're absolutely sure in advance of the results of the session.
        For example, at the end of a compile, Pas-Ed always displays a message
        indicating the results of the compile.  If you write a macro that
        automatically clears this message, you'll lose any error messages should
        an error occur, and you'll have to manually examine the error message
        using the Options/View Last DOS Screen menu option.


Hint:   Conversely, when using Pas-Ed to compile programs written for languages
        other than pascal, the ability to write a macro which operates across
        compile sessions can be a real benefit.  Simply enter the compiler name
        as one of the five user utilities and the file(s) being compiled as the
        utility command line along with the compiler command line switches.  For
        example, we always use a variation of the name "P-xxxxxx.ASM" for our
        Pas-Ed assembler files.  We have TASM.EXE set up as the third user
        utility and have as the command line "PAS-*" plus our TASM switches.  We
        then use the following macro to compile our assembler routines:

             <Alt-F><U><3><Esc><Alt-F1>




Chapter 7 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 44




        This macro opens the File menu, opens the Utility submenu, selects the
        third option (TASM.EXE), runs the utility (compiles our PAS-xxxx.ASM
        files), escapes back to the editor, and hot keys to the last DOS screen,
        which displays the results of the compile.


Hint:   If your keyboard locks up, try holding down the <Ctrl> key and
        alternately pressing the left and right shift keys several times.  This
        will sometimes (not often) unlock the keyboard.  When trying to trace
        the source of the problem, first check to be sure it wasn't caused by
        the program you're writing.  If the problem persists across several
        different programs, it may be a conflict between Pas-Ed's macro
        processor and another program, such as a TSR.  To check this, turn macro
        processing off using the Macros/Turn On/Off menu selection.  Pas-Ed is
        otherwise a plain vanilla program, so if the problem continues after
        macro processing has been turned off, it's probably not being caused by
        Pas-Ed.  Try unloading your TSRs one by one to see if you can find the
        program causing the problem.  As an aside, we regularly use Pas-Ed with
        SidekickPlus and have had no problems.

        If your keyboard locks up during a DOS shell or a compile, debug, or run
        session, then the problem isn't Pas-Ed's macro processor, as it's
        disabled during these sessions.


Hint:   If you run out of memory doing an EMS-to-EMS block copy or move, first
        write the block to a nonsense file, such as TEMP.PAS, using <Ctrl-K><W>,
        and then read TEMP.PAS into the destination file using <Ctrl-K><R>.
        Running out of memory during these transfers may indicate that the
        amount of working DOS memory reserved by Pas-Ed needs to be increased
        using the Options/Memory Usage/Working Memory menu option.  Since only
        one EMS-based file can be mapped into DOS memory at once, EMS-to-EMS
        block transfers are temporarily allocated in working memory.


Hint:   On a related note, remember if you encounter out of memory messages in
        any situation to consider raising the amount of working memory reserved
        by Pas-Ed using the Options/Memory Usage/Working Memory menu option.


Hint:   If your computer doesn't have EMS memory and you have only one or two
        windows open, turn the Options/Swap To EMS/Disk menu option off during
        simple DOS shells and when compiling very small programs.  When EMS/Disk
        swapping is disabled, the heap is compressed for the exec session, and
        enough DOS memory for simple operations should be available providing
        you have only one or, at most, two windows open.  Compressing the heap
        is very much faster than a disk-based DOS memory swap.  If you receive
        out of memory messages during these sessions, first, check to be sure
        you're linking to disk, second, if you have two windows open, try
        closing one window, and finally turn swapping back on.



Chapter 7 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 45




Hint:   If you want to return to your current setup next time Pas-Ed is started
        but you have another project to work on before exiting Pas-Ed, use the
        Options/Write Config File menu option to immediately write the
        PAS-ED.CFG configuration file to disk, thus saving your current setup.
        Then turn the Config Auto Save option off to ensure that Pas-Ed won't
        save your new setup upon exit.  When you restart Pas-Ed, your current
        setup will be restored.


Hint:   If you have a hint that others might find useful and you wouldn't mind
        sharing, please sent it to Hedco so it can be included in the next
        version of the manual.









































Chapter 7 - Hints On Using Pas-Ed                        Pas-Ed Manual - Page 46

